CREATE OR REPLACE FORCE EDITIONABLE VIEW "IDM_RPT_DATA"."IDMRPT_USER_EVENTS_V2" ("EVENT_SEQ_NO", "EVENT_NAME", "EVENT_ID", "EVENT_DATETIME", "EVENT_SOURCE_USER", "EVENT_DESTINATION_USER", "EVENT_TARGET_USER_NAME", "MESSAGE", "FN", "RV31", "IDV_NAME", "IDV_HOST", "IDV_ID", "RPT_DRV_ID", "IDENTITY_ID", "FIRST_NAME", "LAST_NAME", "MIDDLE_INITIAL", "FULL_NAME", "JOB_TITLE", "DEPARTMENT", "LOCATION", "EMAIL_ADDRESS", "IDENTITY_DESC", "RV43", "XDAS_PROVIDER", "XDAS_REGISTRY", "XDAS_CLASS", "XDAS_IDENTIFIER", "XDAS_TAXONOMY_NAME", "XDAS_OUTCOME", "XDAS_OUTCOME_NAME", "XDAS_DETAIL") AS 
  SELECT event.id event_seq_no, 
  event.evt event_name, 
  event.rv40 event_id, 
  event.dt event_datetime, 
  idm_rpt_data.get_formatted_user_dn(event.rv35, event.sun) event_source_user, 
  idm_rpt_data.get_formatted_user_dn(event.rv45, event.dun) event_destination_user, 
  id.full_name event_target_user_name, 
  event.msg message, 
  event.fn, 
  event.rv31, 
  idv_driver.idv_name, 
  idv_driver.idv_host, 
  idv_driver.idv_id, 
  idv_driver.rpt_drv_id, 
  id.identity_id, 
  id.first_name, 
  id.last_name, 
  id.middle_initial, 
  id.full_name, 
  id.job_title, 
  id.department, 
  id.location, 
  id.email_address, 
  id.identity_desc, 
  event.rv43, 
  event.xdasprov xdas_provider, 
  event.xdasreg xdas_registry, 
  event.xdasclass xdas_class, 
  event.xdasid xdas_identifier, 
  event.xdastaxname xdas_taxonomy_name,
  event.xdasoutcome xdas_outcome,
  event.xdasoutcomename xdas_outcome_name,
  event.xdasdetail xdas_detail
  FROM
    idm_rpt_data.idmrpt_identity_cs_v id
  INNER JOIN idm_rpt_data.idmrpt_idv_acct_all_v id_acct ON id.identity_id = id_acct.identity_id
  INNER JOIN idm_rpt_data.idmrpt_idv_v idv ON id_acct.idv_id = idv.idv_id
  LEFT OUTER JOIN idm_rpt_data.idmrpt_rpt_driver_v idv_driver ON id_acct.rpt_drv_id = idv_driver.rpt_drv_id
  INNER JOIN IDM_RPT_DATA.sentinel_events event ON 
(CASE 
  WHEN event.sun IS NOT NULL AND id_acct.idv_acct_user = lower(event.sun) THEN 1
  ELSE
  (CASE
    WHEN event.dun IS NULL THEN 
    (CASE
      WHEN event.sun IS NULL AND id_acct.idv_acct_user = lower(event.iuid) THEN 1
      WHEN id_acct.idv_acct_user = lower(event.sun) THEN 1
      ELSE 0
    END) 
    ELSE 
      (CASE
        WHEN event.dun LIKE '%cn=%o=%' AND lower(event.dun) = lower(id_acct.idv_acct_dn) THEN 1
        ELSE 
            CASE
              WHEN event.dun = 'loginDisabled' OR event.dun = 'Locked By Intruder' OR event.dun LIKE 'Login Intruder%' AND id_acct.idv_acct_user = lower(event.sun) THEN 1
              WHEN id_acct.idv_acct_user = lower(event.dun) THEN 1
              ELSE 0
            END
        END)
END)
END) = 1
  AND 
(CASE
   WHEN event.rv45 IS NULL AND id_acct.idv_acct_domain = lower(event.rv35) THEN 1
   ELSE 
      CASE
          WHEN event.rv45 LIKE '%cn=%o=%' AND id_acct.idv_acct_dn = lower(event.rv45) THEN 1
		  WHEN event.rv35 IS NOT NULL AND id_acct.idv_acct_domain = lower(event.rv35) THEN 1
          WHEN id_acct.idv_acct_domain = lower(event.rv45) THEN 1
          ELSE 0
      END
END) = 1;

GRANT SELECT ON idm_rpt_data.IDMRPT_USER_EVENTS_V2  TO idmrptuser;
CREATE OR REPLACE PUBLIC SYNONYM IDMRPT_USER_EVENTS_V2 for IDM_RPT_DATA.IDMRPT_USER_EVENTS_V2; 
